'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _icon = require('antd-mobile/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

require('antd-mobile/lib/icon/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _View = require('../View');

var _View2 = _interopRequireDefault(_View);

var _MobileDetect = require('../../utils/MobileDetect');

var _MobileDetect2 = _interopRequireDefault(_MobileDetect);

var _constants = require('../../constants');

var CONST = _interopRequireWildcard(_constants);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// 加载Histroy的临界ScrollTop 
var LOADING_THRESHOLD = 100;

var ChatView = (_temp2 = _class = function (_Component) {
    _inherits(ChatView, _Component);

    function ChatView() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, ChatView);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ChatView.__proto__ || Object.getPrototypeOf(ChatView)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            data: [],
            allLoaded: false

            // 更新前的scrollTop
        }, _this._lastScrollTop = 0, _this._historyRequestCount = 0, _this._shouldAdjustPosition = false, _this.scrollToBottom = function () {
            (0, _jquery2.default)('#' + _this.props.id).animate({
                scrollTop: (0, _jquery2.default)('#' + _this.props.id)[0].scrollHeight
            });
        }, _this.scrollToNewMsg = function () {
            (0, _jquery2.default)('#' + _this.props.id).animate({
                scrollTop: _this.oldScrollHeight
            });
        }, _this.append = function (data, sort) {
            _this.setState({
                data: !sort ? [data].concat(_toConsumableArray(_this.state.data)) : [data].concat(_toConsumableArray(_this.state.data)).sort(sort)
            });
            setTimeout(function () {
                _this.scrollToBottom();
            }, 200);
        }, _this.remove = function (find) {
            _this.setState({
                data: _this.state.data.removeByCondition(find)
            });
        }, _this.getNewMessage = function () {
            _this.props.getNewMessage && _this.props.getNewMessage(function (data, sort) {

                _this.oldScrollHeight = (0, _jquery2.default)('#' + _this.props.id)[0].scrollHeight;
                // 向前加数据
                _this.setState({
                    data: !sort ? [].concat(_toConsumableArray(data), _toConsumableArray(_this.state.data)) : [].concat(_toConsumableArray(data), _toConsumableArray(_this.state.data)).sort(sort)
                });
                // 滚动容器至底部
                setTimeout(function () {
                    _this.scrollToBottom();
                }, 200);
            });
        }, _this.getHistory = function (complete) {
            // 开启适配高度的开关
            _this._shouldAdjustPosition = true;
            _this.props.getHistory && _this.props.getHistory(function (data, allLoaded) {
                // 向后加数据
                _this.setState({
                    data: [].concat(_toConsumableArray(_this.state.data), _toConsumableArray(data)),
                    allLoaded: allLoaded
                });
                setTimeout(function () {
                    complete && complete();
                }, 200);
            }, _this._historyRequestCount);

            _this._historyRequestCount += 1;
        }, _this.renderHeader = function () {
            var styles = {
                icon: {
                    justifyContent: 'space-around',
                    alignItems: 'center',
                    textAlign: 'center',
                    verticalAlign: 'middle',
                    height: LOADING_THRESHOLD,
                    width: '100%',
                    flexDirection: 'row',
                    fontSize: 28,
                    color: 'rgb(160, 160, 160)'
                },
                sep: {
                    height: 1,
                    width: '25%',
                    backgroundColor: 'rgb(220,220,225)'
                }
            };
            return _this.state.allLoaded ? _react2.default.createElement(
                _View2.default,
                { style: styles.icon },
                _react2.default.createElement('div', { style: styles.sep }),
                _this.props.allLoadedText,
                _react2.default.createElement('div', { style: styles.sep })
            ) : _react2.default.createElement(
                _View2.default,
                { style: styles.icon },
                _react2.default.createElement(_icon2.default, { type: require('../../assets/loading.svg') })
            );
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    // 请求历史消息的次数


    // 是否应该适配chatview的高度


    _createClass(ChatView, [{
        key: 'init',
        value: function init() {
            var _this2 = this;

            // 初始化加载一次历史记录
            this.getHistory(function () {

                // 监听滚动
                var chatview = (0, _jquery2.default)('#' + _this2.props.id);
                chatview.on('scroll', function () {

                    // 使用timeout来降低触发频率
                    if (_this2.pollingTimeout) {
                        clearTimeout(_this2.pollingTimeout);
                    }
                    _this2.pollingTimeout = setTimeout(function () {
                        if (chatview.scrollTop() < LOADING_THRESHOLD && !_this2.state.allLoaded && !_this2._shouldAdjustPosition) {
                            _this2.getHistory();
                        }
                    }, 200);
                });

                // 获取新消息并轮询
                _this2.getNewMessage();
                if (_this2.props.requestInterval !== 0) {
                    // 轮询
                    _this2.timer = setInterval(_this2.getNewMessage, _this2.props.requestInterval);
                }
            });
        }
    }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate() {
            if (this._shouldAdjustPosition) {
                this._lastScrollTop = (0, _jquery2.default)('#' + this.props.id)[0].scrollHeight - (0, _jquery2.default)('#' + this.props.id).scrollTop();
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            if (this._shouldAdjustPosition && (0, _jquery2.default)('#' + this.props.id)[0].scrollHeight > (0, _jquery2.default)('#' + this.props.id)[0].clientHeight) {
                this._shouldAdjustPosition = false;
                var chatview = (0, _jquery2.default)('#' + this.props.id);
                chatview.scrollTop(chatview[0].scrollHeight - this._lastScrollTop);
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            clearInterval(this.timer);
        }

        /**
         * 新增一条数据
         */


        /**
         * 移除一条记录
         */


        /**
         * 获取新消息
         */


        /**
         * 获取历史消息
         */


        // 渲染Header

    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                style = _props.style,
                renderRow = _props.renderRow;

            var chatviewStyle = _extends({
                height: document.documentElement.clientHeight - (_MobileDetect2.default.isWechat || _MobileDetect2.default.isApp ? 0 : 90),
                width: document.documentElement.clientWidth,
                backgroundColor: CONST.BACKGROUND_COLOR,
                WebkitOverflowScrolling: 'touch',
                overflowX: 'hidden',
                overflowY: 'scroll'
            }, style);
            return _react2.default.createElement(
                'div',
                { id: this.props.id, style: chatviewStyle },
                this.renderHeader(),
                [].concat(_toConsumableArray(this.state.data)).reverse().map(function (rowData, index) {
                    return renderRow(rowData, index);
                })
            );
        }
    }]);

    return ChatView;
}(_react.Component), _class.propTypes = {
    id: _react.PropTypes.string,
    renderRow: _react.PropTypes.func,
    style: _react.PropTypes.object,
    allLoadedText: _react.PropTypes.string,
    getHistory: _react.PropTypes.func,
    getNewMessage: _react.PropTypes.func,
    requestInterval: _react.PropTypes.number
}, _class.defaultProps = {
    id: 'chatview',
    style: {},
    allLoadedText: '没有更多了',
    requestInterval: 8000
}, _temp2);
exports.default = ChatView;