'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _menu = require('antd-mobile/lib/menu');

var _menu2 = _interopRequireDefault(_menu);

var _icon = require('antd-mobile/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp, _initialiseProps;

require('antd-mobile/lib/menu/style/css');

require('antd-mobile/lib/icon/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _View = require('../View');

var _View2 = _interopRequireDefault(_View);

var _ScrollView = require('../ScrollView');

var _ScrollView2 = _interopRequireDefault(_ScrollView);

var _DatePicker = require('../DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _isarray = require('isarray');

var _isarray2 = _interopRequireDefault(_isarray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BAR_HEIGHT = 80;
var PRIMARY_COLOR = 'rgb(74, 144, 226)';
var TITLE_COLOR = 'rgb(60, 60, 60)';
var SUBTITLE_COLOR = 'rgb(160, 160, 160)';
var BORDER_COLOR = 'rgb(220, 220, 220)';
var BACKGROUND_COLOR = 'rgb(245,245,249)';

var valuesCache = {};
var labels = {};
var FilterBarPro = (_temp = _class = function (_React$Component) {
    _inherits(FilterBarPro, _React$Component);

    function FilterBarPro(props) {
        _classCallCheck(this, FilterBarPro);

        var _this = _possibleConstructorReturn(this, (FilterBarPro.__proto__ || Object.getPrototypeOf(FilterBarPro)).call(this, props));

        _initialiseProps.call(_this);

        var cValuePro = props.conditionsPro ? valuesCache && valuesCache[props.filterBarId] ? valuesCache[props.filterBarId] : props.defaultValuesPro ? props.defaultValuesPro : props.conditionsPro.map(function (condition) {
            switch (condition.type) {
                case 'radio':
                    return { value: false };
                case 'list':
                    return { value: '' };
                case 'custom':
                    return { value: '', label: '请选择' };
                case 'date':
                    return {
                        label: '全部日期',
                        value: {
                            label: '',
                            start: '',
                            end: '',
                            type: ''
                        }
                    };
                default:
                    return { value: '' };
            }
        }) : '';
        var dateI = props.conditionsPro && props.conditionsPro.findIndex(function (x) {
            return x.type === 'date';
        });
        var format = props.conditionsPro && props.conditionsPro[dateI] && props.conditionsPro[dateI].format ? props.conditionsPro[dateI].format : 'YYYY-MM-DD';
        _this.state = {
            selectedIndex: -1, // -1时表示没有菜单是激活状态
            conditions: props.conditions ? _this.generateConditions(props.conditions) : '', // 普通筛选的条件
            conditionsPro: props.conditionsPro ? props.conditionsPro : '', // 高级筛选的条件
            valuesPro: cValuePro,
            offsetTop: -500,
            labels: props.conditions && props.conditions.map(function () {
                return '';
            }),

            currents: props.conditionsPro && function () {
                // 自定义日期范围的年月时间点
                var current = cValuePro[dateI].value.start ? (0, _moment2.default)(cValuePro[dateI].value.start, format) : (0, _moment2.default)();
                return [current, current, current, current];
            }(),
            selectedDate: props.conditionsPro && {
                start: cValuePro[dateI].value.start ? (0, _moment2.default)(cValuePro[dateI].value.start, format) : '',
                end: cValuePro[dateI].value.end ? (0, _moment2.default)(cValuePro[dateI].value.end, format) : ''
            }
        };
        return _this;
    }

    _createClass(FilterBarPro, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.setState({
                offsetTop: (0, _reactDom.findDOMNode)(this.bar).offsetTop,
                labels: labels[this.props.filterBarId] && labels[this.props.filterBarId].length ? labels[this.props.filterBarId] : this.state.labels
            });
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            labels[this.props.filterBarId] = this.state.labels;
            valuesCache[this.props.filterBarId] = this.state.valuesPro;
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.conditions) {
                this.setState({
                    conditions: this.generateConditions(nextProps.conditions)
                });
            }
            if (nextProps.conditionsPro) {
                this.setState({
                    conditionsPro: nextProps.conditionsPro
                });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _state = this.state,
                selectedIndex = _state.selectedIndex,
                conditions = _state.conditions,
                conditionsPro = _state.conditionsPro;

            return conditions.length > 0 || conditionsPro.length > 0 ? _react2.default.createElement(
                _View2.default,
                { style: styles.container, ref: function ref(o) {
                        return _this2.bar = o;
                    } },
                conditions && conditions.length > 0 ? this.renderFilter() : null,
                conditionsPro && conditionsPro.length > 0 ? this.renderFilterPro() : null,
                selectedIndex !== -1 ? _react2.default.createElement('div', { style: _extends({}, styles.shade, { top: this.state.offsetTop + BAR_HEIGHT + 1 }), onClick: this.hideMenu }) : null,
                this.renderPicker(),
                this.renderPickerPro()
            ) : null;
        }
    }]);

    return FilterBarPro;
}(_react2.default.Component), _class.propTypes = {
    filterBarId: _react2.default.PropTypes.any,
    conditions: _react2.default.PropTypes.array,
    conditionsPro: _react2.default.PropTypes.array,
    values: _react2.default.PropTypes.array,
    defaultValuesPro: _react2.default.PropTypes.array,
    onChange: _react2.default.PropTypes.func,
    onClick: _react2.default.PropTypes.func,
    onCustomClick: _react2.default.PropTypes.func,
    onChangePro: _react2.default.PropTypes.func,
    switchBtns: _react2.default.PropTypes.array
}, _class.defaultProps = {
    onClick: function onClick(i, cb) {
        cb(null);
    },
    switchBtns: [],
    filterBarId: 'temp'
}, _initialiseProps = function _initialiseProps() {
    var _this3 = this;

    this.generateConditions = function (conditions) {
        return conditions.map(function (condition) {
            if (condition.searchByCondition(function (a) {
                return a.hasOwnProperty('children');
            })) {
                if (!(0, _isarray2.default)(condition)) {
                    console.error('FilterBar: condition不是Array类型');
                    return null;
                }
                return condition.map(function (item) {
                    if (!item.hasOwnProperty('children')) return _extends({}, item, { isLeaf: true });
                    return item;
                });
            }
            return condition;
        });
    };

    this.setLabel = function (label, i) {
        var labels = _this3.state.labels;
        labels.splice(i, 1, label);
        _this3.setState({
            labels: labels
        });
    };

    this.onItemClick = function (i) {
        _this3.setState({ selectedIndex: -1 });
        if (i !== 4) {
            _this3.props.onClick(i, function (label) {
                if (!label) {
                    if (i === _this3.state.selectedIndex) {
                        _this3.setState({ selectedIndex: -1 });
                    } else {
                        _this3.setState({ selectedIndex: i });
                    }
                } else {
                    var _labels = _this3.state.labels;
                    _labels.splice(i, 1, label);
                    _this3.setState({ labels: _labels });
                }
            });
        } else {
            if (i === _this3.state.selectedIndex) {
                _this3.setState({ selectedIndex: -1 });
            } else {
                _this3.setState({ selectedIndex: i });
            }
        }
    };

    this.onCustomClick = function (i) {

        _this3.props.onCustomClick(i, function (label, value) {
            var valuesPro = _this3.state.valuesPro;
            valuesPro.splice(i, 1, { label: label, value: value });
            _this3.setState({ valuesPro: valuesPro });
        });
    };

    this.onChangePro = function () {
        var valuesPro = _this3.state.valuesPro;

        _this3.props.onChangePro && _this3.props.onChangePro(valuesPro);
        _this3.setState({ selectedIndex: -1 });
        valuesCache[_this3.props.filterBarId] = valuesPro;
    };

    this.onReset = function () {
        var conditionsPro = _this3.state.conditionsPro;

        _this3.setState({
            valuesPro: conditionsPro.map(function (condition) {
                switch (condition.type) {
                    case 'radio':
                        return { value: false };
                    case 'list':
                        return { value: '' };
                    case 'custom':
                        return { value: '', label: '请选择' };
                    case 'date':
                        return {
                            label: '全部日期',
                            value: {
                                label: '',
                                start: '',
                                end: '',
                                type: ''
                            }
                        };
                    default:
                        return { value: '' };
                }
            })
        });
    };

    this.onDateClick = function (label, i) {
        var format = _this3.props.conditionsPro[i] && _this3.props.conditionsPro[i].format ? _this3.props.conditionsPro[i].format : 'YYYY-MM-DD';
        if (label === '自定义日期') {
            (0, _DatePicker2.default)({
                checked: _this3.state.valuesPro[i].value,
                type: 'onlyCalendar',
                onSelect: function onSelect(newDate) {
                    var valuesPro = _this3.state.valuesPro;
                    valuesPro.splice(i, 1, { label: label, value: newDate });
                    _this3.setState({ valuesPro: valuesPro });
                }
            });
            return;
        }
        var checked = {
            label: label,
            start: function () {
                switch (label) {
                    case '今日':
                        return (0, _moment2.default)().format(format);
                    case '昨日':
                        return (0, _moment2.default)().subtract(1, 'days').format(format);
                    case '本周':
                        return (0, _moment2.default)().startOf('week').format(format);
                    case '上周':
                        return (0, _moment2.default)().subtract(1, 'weeks').startOf('week').format(format);
                    case '本月':
                        return (0, _moment2.default)().startOf('month').format(format);
                    case '上月':
                        return (0, _moment2.default)().subtract(1, 'months').startOf('month').format(format);
                    case '一天内':
                        return (0, _moment2.default)().subtract(1, 'days').format(format);
                    case '一周内':
                        return (0, _moment2.default)().subtract(1, 'weeks').format(format);
                    case '一月内':
                        return (0, _moment2.default)().subtract(1, 'months').format(format);
                    case '一年内':
                        return (0, _moment2.default)().subtract(1, 'years').format(format);
                    default:
                        return '';
                }
            }(),
            end: function () {
                switch (label) {
                    case '今日':
                        return (0, _moment2.default)().format(format);
                    case '昨日':
                        return (0, _moment2.default)().subtract(1, 'days').format(format);
                    case '本周':
                        return (0, _moment2.default)().endOf('week').format(format);
                    case '上周':
                        return (0, _moment2.default)().subtract(1, 'weeks').endOf('week').format(format);
                    case '本月':
                        return (0, _moment2.default)().endOf('month').format(format);
                    case '上月':
                        return (0, _moment2.default)().subtract(1, 'months').endOf('month').format(format);
                    case '一天内':
                    case '一周内':
                    case '一月内':
                    case '一年内':
                        return (0, _moment2.default)().format(format);
                    default:
                        return '';
                }
            }(),
            type: ''
        };
        var valuesPro = _this3.state.valuesPro;
        valuesPro.splice(i, 1, { label: label, value: checked });
        _this3.setState({ valuesPro: valuesPro });
    };

    this.hideMenu = function () {
        _this3.setState({ selectedIndex: -1 });
    };

    this.renderFilter = function () {
        var _props = _this3.props,
            values = _props.values,
            switchBtns = _props.switchBtns;
        var _state2 = _this3.state,
            selectedIndex = _state2.selectedIndex,
            conditions = _state2.conditions,
            conditionsPro = _state2.conditionsPro,
            labels = _state2.labels;

        return conditions.map(function (item, i) {
            var value = values[i];
            var data = conditions[i];
            // 验证数据类型
            if (!(0, _isarray2.default)(value)) {
                console.error('FilterBar: \u7B2C' + i + '\u4E2Avalue\u4E0D\u662FArray\u7C7B\u578B');
                return null;
            }
            // 获取value[0]相应的object，设置label为1级
            var first = data.findByCondition(function (a) {
                return a.value === value[0];
            });
            var label = first && first.label;
            // 如果有children，去匹配children的值
            if (first && first.hasOwnProperty('children')) {
                var second = first.children.findByCondition(function (a) {
                    return a.value === value[1];
                });
                label = second && second.label;
            }
            // state的label优先显示
            label = labels[i] || label || ' ';
            // 是否被选择
            var isSelected = selectedIndex === i;
            // 布局和样式
            var itemStyle = _extends({}, styles.filterItem, { width: Math.round(1 / (conditionsPro ? conditions.length + 1 : conditions.length) * 10000) / 100 + '%' });
            // 移除最后一个item的右边框
            if (i === conditions.length - 1 && conditionsPro === null) itemStyle = _extends({}, itemStyle, { borderRight: 0 });
            var itemTitleStyle = !isSelected ? styles.itemTitle : _extends({}, styles.itemTitle, styles.itemTitleSelected);
            var iconStyle = !isSelected ? styles.icon : _extends({}, styles.icon, styles.iconUp);
            var iconColor = !isSelected ? 'rgb(200,200,200)' : PRIMARY_COLOR;
            var isShowSwitchBtn = switchBtns.searchByCondition(function (index) {
                return i === index;
            });
            return _react2.default.createElement(
                _View2.default,
                { style: itemStyle, key: i, onClick: function onClick() {
                        return _this3.onItemClick(i);
                    } },
                _react2.default.createElement(
                    _View2.default,
                    { style: itemTitleStyle },
                    label
                ),
                _react2.default.createElement(
                    _View2.default,
                    { style: iconStyle },
                    _react2.default.createElement(_icon2.default, { type: isShowSwitchBtn ? require('../../assets/switch.svg') : require('../../assets/triangle.svg'), size: isShowSwitchBtn ? 'xs' : 'xxs', color: iconColor })
                )
            );
        });
    };

    this.renderFilterPro = function () {
        var _state3 = _this3.state,
            selectedIndex = _state3.selectedIndex,
            conditions = _state3.conditions;

        var isSelected = selectedIndex === 4;
        var itemStyle = _extends({}, styles.filterItem, { width: Math.round(1 / (conditions ? conditions.length + 1 : 1) * 10000) / 100 + '%' });
        // 移除最后一个item的右边框
        itemStyle = _extends({}, itemStyle, { borderRight: 0 });
        var itemTitleStyle = !isSelected ? styles.itemTitle : _extends({}, styles.itemTitle, styles.itemTitleSelected);
        var iconStyle = !isSelected ? styles.icon : _extends({}, styles.icon, styles.iconUp);
        var iconColor = !isSelected ? 'rgb(200,200,200)' : PRIMARY_COLOR;
        return _react2.default.createElement(
            _View2.default,
            { style: itemStyle, onClick: function onClick() {
                    return _this3.onItemClick(4);
                } },
            _react2.default.createElement(
                _View2.default,
                { style: itemTitleStyle },
                '\u9AD8\u7EA7\u7B5B\u9009'
            ),
            _react2.default.createElement(
                _View2.default,
                { style: iconStyle },
                _react2.default.createElement(_icon2.default, { type: require('../../assets/triangle.svg'), size: 'xxs', color: iconColor })
            )
        );
    };

    this.renderPicker = function () {
        var values = _this3.props.values;
        var _state4 = _this3.state,
            selectedIndex = _state4.selectedIndex,
            conditions = _state4.conditions;

        return selectedIndex !== -1 && selectedIndex !== 4 ? function () {
            // 获取Menu的data,value,onChange
            var data = conditions[selectedIndex];
            var style = _extends({}, styles.menu, { top: _this3.state.offsetTop + BAR_HEIGHT + 1 });
            var value = values[selectedIndex];
            var onChange = function onChange(newValue) {
                if (newValue.toString() === value.toString()) return;
                // 设置label
                _this3.setState({
                    labels: _this3.state.labels.map(function (label, i) {
                        if (i === selectedIndex) {
                            return '';
                        }
                        return label;
                    })
                });
                _this3.props.onChange && _this3.props.onChange(values.map(function (value, i) {
                    if (i === selectedIndex) return newValue;
                    return value;
                }), selectedIndex);
                _this3.hideMenu();
            };
            var level = data.searchByCondition(function (a) {
                return a.hasOwnProperty('children');
            }) ? 2 : 1;
            var height = Math.min(data.length * 100, 500);
            return _react2.default.createElement(
                'div',
                { style: style },
                _react2.default.createElement(_menu2.default, {
                    height: height,
                    data: data,
                    level: level,
                    value: value,
                    onChange: onChange
                })
            );
        }() : null;
    };

    this.renderPickerPro = function () {
        var dateRow = ['全部日期', '今日', '昨日', '本周', '上周', '本月', '上月'];
        var _state5 = _this3.state,
            selectedIndex = _state5.selectedIndex,
            conditionsPro = _state5.conditionsPro,
            valuesPro = _state5.valuesPro;

        if (selectedIndex !== 4) return null;
        var height = Math.min(conditionsPro.length * 200, document.documentElement.clientHeight / 2);
        var style = _extends({}, styles.menu, {
            top: _this3.state.offsetTop + BAR_HEIGHT + 1
        });
        var sidebar = _react2.default.createElement(
            _ScrollView2.default,
            {

                backgroundColor: 'white',
                height: height
            },
            conditionsPro.map(function (item, i) {
                switch (item.type) {
                    case 'radio':
                        return _react2.default.createElement(
                            _View2.default,
                            {
                                key: i, style: _extends({}, styles.titlePro, { borderBottom: '1px solid ' + BORDER_COLOR }),
                                onClick: function onClick() {
                                    _this3.setState({
                                        valuesPro: valuesPro.map(function (valuesItem, j) {
                                            if (j === i) {
                                                return { value: !valuesItem.value };
                                            }
                                            return valuesItem;
                                        })
                                    });
                                } },
                            _react2.default.createElement(
                                _View2.default,
                                { style: { color: '' + TITLE_COLOR } },
                                item.name
                            ),
                            _react2.default.createElement(
                                _View2.default,
                                { style: valuesPro[i].value ? _extends({}, styles.check, { border: '1.5px solid ' + PRIMARY_COLOR }) : styles.check },
                                valuesPro[i].value ? _react2.default.createElement(_icon2.default, { type: 'check', color: PRIMARY_COLOR }) : null
                            )
                        );
                    case 'list':
                        return _react2.default.createElement(
                            'div',
                            {
                                key: i,
                                style: { borderBottom: '1px solid ' + BORDER_COLOR }
                            },
                            _react2.default.createElement(
                                _View2.default,
                                { style: _extends({}, styles.titlePro, { color: '' + TITLE_COLOR }) },
                                item.name
                            ),
                            _react2.default.createElement(
                                _View2.default,
                                { style: { padding: '0px 0px 20px 30px' } },
                                item.data.map(function (option) {
                                    var valuei = valuesPro[i].value;
                                    var isSelected = option.value === valuei;
                                    var optionStyle = !isSelected ? styles.option : _extends({}, styles.option, { color: PRIMARY_COLOR, border: '1px solid' });
                                    return _react2.default.createElement(
                                        _View2.default,
                                        {
                                            key: option.label,
                                            style: _extends({}, optionStyle, { margin: '0 30px 30px 0' }),
                                            onClick: function onClick() {
                                                _this3.setState({
                                                    valuesPro: valuesPro.map(function (valItem, j) {
                                                        if (j === i) return { value: option.value };
                                                        return valItem;
                                                    })
                                                });
                                            }
                                        },
                                        option.label
                                    );
                                })
                            )
                        );
                    case 'custom':
                        return _react2.default.createElement(
                            _View2.default,
                            {
                                style: _extends({}, styles.titlePro, { borderBottom: '1px solid ' + BORDER_COLOR, flexWrap: 'nowrap' }),
                                key: i,
                                onClick: function onClick() {
                                    return _this3.onCustomClick(i);
                                }
                            },
                            _react2.default.createElement(
                                _View2.default,
                                { style: { color: '' + TITLE_COLOR } },
                                item.name
                            ),
                            _react2.default.createElement(
                                _View2.default,
                                { style: { alignItems: 'center', flexWrap: 'nowrap' } },
                                _react2.default.createElement(
                                    _View2.default,
                                    { style: valuesPro[i].label === '请选择' ? { color: SUBTITLE_COLOR } : { color: PRIMARY_COLOR } },
                                    valuesPro[i].label
                                ),
                                _react2.default.createElement(_icon2.default, { type: 'right', size: 'sm', color: 'rgb(200,200,200)' })
                            )
                        );
                    case 'date':
                        return _react2.default.createElement(
                            'div',
                            {
                                key: i,
                                style: { borderBottom: '1px solid ' + BORDER_COLOR }
                            },
                            _react2.default.createElement(
                                _View2.default,
                                { style: _extends({}, styles.titlePro, { color: '' + TITLE_COLOR }) },
                                '\u9009\u62E9\u65E5\u671F'
                            ),
                            _react2.default.createElement(
                                _View2.default,
                                { style: { padding: '0px 0px 20px 30px' } },
                                dateRow.map(function (dateName) {
                                    var name = valuesPro[i].label;
                                    var isSelected = dateName === name;
                                    var optionStyle = !isSelected ? styles.option : _extends({}, styles.option, { color: PRIMARY_COLOR, border: '1px solid' });
                                    return _react2.default.createElement(
                                        _View2.default,
                                        {
                                            key: dateName,
                                            style: _extends({}, optionStyle, { margin: '0 30px 30px 0' }),
                                            onClick: function onClick() {
                                                return _this3.onDateClick(dateName, i);
                                            }
                                        },
                                        dateName
                                    );
                                }),
                                _react2.default.createElement(
                                    _View2.default,
                                    {
                                        style: '自定义日期' !== valuesPro[i].label ? styles.option : _extends({}, styles.option, { color: PRIMARY_COLOR, border: '1px solid', margin: '0 30px 30px 0' }),
                                        onClick: function onClick() {
                                            return _this3.onDateClick('自定义日期', i);
                                        }
                                    },
                                    '自定义日期' === valuesPro[i].label ? valuesPro[i].value.start + ' \u81F3 ' + valuesPro[i].value.end : '自定义日期范围'
                                )
                            )
                        );
                    default:
                        return null;
                }
            })
        );
        return _react2.default.createElement(
            'div',
            { style: _extends({}, style, { backgroundColor: BACKGROUND_COLOR }) },
            sidebar,
            _react2.default.createElement(
                _View2.default,
                { style: { justifyContent: 'space-between' } },
                _react2.default.createElement(
                    _View2.default,
                    {
                        onClick: _this3.onReset,
                        style: styles.subButton
                    },
                    '\u91CD\u7F6E'
                ),
                _react2.default.createElement(
                    _View2.default,
                    {
                        onClick: _this3.onChangePro,
                        style: styles.blueButton
                    },
                    '\u5B8C\u6210'
                )
            )
        );
    };
}, _temp);
exports.default = FilterBarPro;

var styles = {
    container: {
        width: '100%',
        height: BAR_HEIGHT,
        backgroundColor: 'white',
        borderBottom: '1px solid ' + BORDER_COLOR,
        justifyContent: 'space-around',
        alignItems: 'center',
        flexWrap: 'no-wrap'
    },
    filterItem: {
        height: '60%',
        justifyContent: 'center',
        alignItems: 'center',
        borderRight: '1px solid ' + BORDER_COLOR,
        flexWrap: 'no-wrap'
    },
    itemTitle: {
        textAlign: 'center',
        fontSize: 28,
        color: SUBTITLE_COLOR,
        marginLeft: 5,
        marginRight: 5,
        whiteSpace: 'nowrap',
        overflow: 'hidden'
    },
    itemTitleSelected: {
        color: PRIMARY_COLOR
    },
    icon: {
        width: 30,
        justifyContent: 'center',
        alignItems: 'center'
    },
    iconUp: {
        transform: 'rotate(180deg)'
    },
    menu: {
        zIndex: 2,
        position: 'absolute',
        left: 0,
        right: 0
    },
    shade: {
        position: 'absolute',
        left: 0,
        right: 0,
        bottom: 0,
        backgroundColor: 'rgba(0,0,0,0.4)',
        zIndex: 1
    },
    check: {
        borderRadius: '50%',
        border: '1.5px solid ' + SUBTITLE_COLOR,
        width: 40,
        height: 40,
        alignItems: 'center',
        justifyContent: 'center'
    },
    option: {
        color: '' + SUBTITLE_COLOR,
        justifyContent: 'center',
        alignItems: 'center',
        border: '1px solid ' + BORDER_COLOR,
        borderRadius: 6,
        padding: '0 30px',
        fontSize: 30,
        height: 50
    },
    subButton: {
        color: 'rgb(160, 160, 160)',
        justifyContent: 'center',
        alignItems: 'center',
        border: '1px solid',
        borderRadius: 6,
        padding: '0 30px',
        fontSize: 30,
        height: 50,
        margin: '10px 30px',
        backgroundColor: 'white'
    },
    blueButton: {
        color: 'rgb(78, 168, 236)',
        justifyContent: 'center',
        alignItems: 'center',
        border: '1px solid',
        borderRadius: 6,
        padding: '0 30px',
        fontSize: 30,
        fontWeight: 'bold',
        height: 50,
        margin: '10px 30px',
        backgroundColor: 'white'
    },
    titlePro: {
        justifyContent: 'space-between',
        padding: '20px 30px'
    }
};