'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _icon = require('antd-mobile/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _actionSheet = require('antd-mobile/lib/action-sheet');

var _actionSheet2 = _interopRequireDefault(_actionSheet);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _modal = require('antd-mobile/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _toast = require('antd-mobile/lib/toast');

var _toast2 = _interopRequireDefault(_toast);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

require('antd-mobile/lib/icon/style/css');

require('antd-mobile/lib/action-sheet/style/css');

require('antd-mobile/lib/modal/style/css');

require('antd-mobile/lib/toast/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _constants = require('../../constants');

var COLORS = _interopRequireWildcard(_constants);

var _Acc = require('../../utils/Acc');

var Acc = _interopRequireWildcard(_Acc);

var _ImageViewer = require('../ImageViewer');

var _ImageViewer2 = _interopRequireDefault(_ImageViewer);

var _View = require('../View');

var _View2 = _interopRequireDefault(_View);

var _MobileDetect = require('../../utils/MobileDetect');

var _MobileDetect2 = _interopRequireDefault(_MobileDetect);

var _wrapProps = require('../../utils/wrapProps');

var _wrapProps2 = _interopRequireDefault(_wrapProps);

var _request = require('../../app/request');

var _request2 = _interopRequireDefault(_request);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AccItem = (_temp = _class = function (_React$Component) {
    _inherits(AccItem, _React$Component);

    function AccItem(props) {
        var _this2 = this;

        _classCallCheck(this, AccItem);

        var _this = _possibleConstructorReturn(this, (AccItem.__proto__ || Object.getPrototypeOf(AccItem)).call(this, props));

        _this.getFileType = function (fileName) {
            return fileName.substring(fileName.lastIndexOf('.') + 1).toLowerCase();
        };

        _this.onAccClick = function (acc) {
            var url = EAP_PATH;
            // 获取文件后缀名，如果是图片文件就调用图片文件的组件预览，否则就跳转至预览页面
            var filetype = _this.getFileType(acc.oName);
            if (filetype === 'png' || filetype === 'jpg' || filetype === 'jpeg' || filetype === 'gif') (0, _ImageViewer2.default)(0, [{ url: url + 'Service/WxGetFile.ashx?hash=' + acc.hash }]);else window.location.href = Acc.getPreviewPath(acc.id);
        };

        _this.onDownloadClick = function (acc) {

            try {
                var filetype = _this.getFileType(acc.oName);
                if (filetype === 'txt' && _MobileDetect2.default.isApp) {
                    _toast2.default.fail('APP暂时不支持txt文件下载！', 2);
                    return;
                }
                var elemIF = document.createElement('iframe');
                elemIF.src = Acc.getImageUrl(acc.hash);
                elemIF.style.display = 'none';
                document.body.appendChild(elemIF);
            } catch (err) {
                _toast2.default.fail('下载异常！', 2);
                // return;
            }
        };

        _this.onDelete = function (acc) {
            _modal2.default.alert('删除附件', '\u6B64\u64CD\u4F5C\u4E0D\u53EF\u9006\uFF0C\u786E\u8BA4\u5220\u9664' + acc.oName + '\u5417\uFF1F', [{
                text: '取消', onPress: function onPress() {
                    // do nothing
                }, style: 'default'
            }, {
                text: '确定', onPress: function () {
                    var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
                        var accId, _ref2, err, accs, newAccs;

                        return _regenerator2.default.wrap(function _callee$(_context) {
                            while (1) {
                                switch (_context.prev = _context.next) {
                                    case 0:
                                        _toast2.default.loading('正在删除', 0);
                                        accId = '' + acc.id;
                                        _context.next = 4;
                                        return (0, _request2.default)(API + '/EAPAcc/DeleteAcc?id=' + accId);

                                    case 4:
                                        _ref2 = _context.sent;
                                        err = _ref2.err;

                                        if (!err) {
                                            _toast2.default.success('删除成功', 1);
                                            accs = _this.state.accs;
                                            newAccs = accs.removeByCondition(function (i) {
                                                return i.id === acc.id;
                                            });

                                            _this.setState({
                                                accs: newAccs
                                            });
                                        } else {
                                            _toast2.default.fail(err + '\uFF0C\u5220\u9664\u5931\u8D25', 2);
                                        }

                                    case 7:
                                    case 'end':
                                        return _context.stop();
                                }
                            }
                        }, _callee, _this2);
                    }));

                    return function onPress() {
                        return _ref.apply(this, arguments);
                    };
                }(), style: { fontWeight: 'bold' }
            }]);
        };

        _this.showActionSheet = function (acc) {
            var IOSBUTTONS = ['预览', '删除', '取消'];
            var BUTTONS = ['预览', '下载', '删除', '取消'];
            if (_MobileDetect2.default.isIOS) {
                _actionSheet2.default.showActionSheetWithOptions({
                    options: IOSBUTTONS,
                    cancelButtonIndex: IOSBUTTONS.length - 1,
                    destructiveButtonIndex: IOSBUTTONS.length - 2,
                    // title: acc.oName,
                    message: acc.oName,
                    maskClosable: true,
                    wrapProps: _wrapProps2.default
                }, function (buttonIndex) {
                    if (buttonIndex === IOSBUTTONS.length - 1) return;
                    if (buttonIndex === 0) {
                        _this.onAccClick(acc);
                    } else if (buttonIndex === IOSBUTTONS.length - 2) {
                        _this.onDelete(acc);
                    }
                });
            } else {
                _actionSheet2.default.showActionSheetWithOptions({
                    options: BUTTONS,
                    cancelButtonIndex: BUTTONS.length - 1,
                    destructiveButtonIndex: BUTTONS.length - 2,
                    // title: acc.oName,
                    message: acc.oName,
                    maskClosable: true,
                    wrapProps: _wrapProps2.default
                }, function (buttonIndex) {
                    if (buttonIndex === BUTTONS.length - 1) return;
                    if (buttonIndex === 0) {
                        _this.onAccClick(acc);
                    } else if (buttonIndex === BUTTONS.length - 2) {
                        _this.onDelete(acc);
                    } else if (buttonIndex === 1) {
                        _this.onDownloadClick(acc);
                    }
                });
            }
        };

        _this.state = {
            accs: props.accs
        };
        return _this;
    }

    _createClass(AccItem, [{
        key: 'getFileImg',
        value: function getFileImg(acc) {
            var url = EAP_PATH;
            var filetype = this.getFileType(acc.oName);
            if (filetype === 'png' || filetype === 'jpg' || filetype === 'jpeg' || filetype === 'gif') {
                return url + 'Service/WxGetFile.ashx?imgSize=small&hash=' + acc.hash;
            } else if (filetype === 'txt') return url + 'Images/Yunpan/txt80.png';else if (filetype === 'xls' || filetype === 'xlsx') return url + 'Images/Yunpan/Xls80.png';else if (filetype === 'doc' || filetype === 'docx') return url + 'Images/Yunpan/Doc80.png';else if (filetype === 'pptx' || filetype === 'ppt') return url + 'Images/Yunpan/PPT80.png';else if (filetype === 'zip' || filetype === 'rar') return url + 'Images/Yunpan/Zip80.png';else if (filetype === 'pdf') return url + 'Images/Yunpan/PDF80.png';else return url + 'Images/Yunpan/Unknown80.png';
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var accs = this.state.accs;

            return _react2.default.createElement(
                _View2.default,
                { style: accs.length === 0 ? styles.hide : { width: '95%', margin: '10px auto', fontSize: 26 } },
                _react2.default.createElement(
                    _View2.default,
                    { style: { width: '100%' } },
                    accs.map(function (acc, i) {
                        return _react2.default.createElement(
                            _View2.default,
                            { key: i, style: _extends({}, styles.accRow, { borderBottom: i === accs.length - 1 ? '0' : '1px solid ' + COLORS.BORDER_COLOR }), onClick: function onClick() {
                                    return _this3.showActionSheet(acc);
                                } },
                            _react2.default.createElement('img', { src: _this3.getFileImg(acc), style: styles.fileImg }),
                            _react2.default.createElement(
                                _View2.default,
                                { style: _extends({}, styles.label, { color: COLORS.TITLE_COLOR }) },
                                acc.oName,
                                _react2.default.createElement(
                                    'span',
                                    { style: styles.size },
                                    '(' + parseInt(acc.size / 1024) + 'KB)'
                                )
                            ),
                            _react2.default.createElement(
                                _View2.default,
                                { style: styles.arrow },
                                _react2.default.createElement(_icon2.default, { type: 'right', color: COLORS.SUBTITLE_COLOR, size: 'md' })
                            )
                        );
                    })
                )
            );
        }
    }]);

    return AccItem;
}(_react2.default.Component), _class.propTypes = {
    accs: _react2.default.PropTypes.array
}, _class.defaultProps = {
    accs: []
}, _temp);
exports.default = AccItem;


var styles = {
    container: {
        width: '100%'
    },
    labelRow: {
        alignItems: 'center',
        height: 80,
        width: '100%'
    },
    icon: {
        height: 40,
        width: 40,
        marginLeft: 30
    },
    label: {
        fontSize: 24,
        color: COLORS.SUBTITLE_COLOR,
        marginLeft: 10,
        flex: 1,
        height: '100%',
        alignItems: 'center',
        overflow: 'hidden'
    },
    accRow: {
        marginLeft: 30,
        width: '100%',
        height: 100,
        alignItems: 'center'
    },
    fileImg: {
        width: 60,
        height: 60,
        borderRadius: 8
    },
    size: {
        color: COLORS.SUBTITLE_COLOR,
        marginLeft: 10
    },
    arrow: {
        marginRight: 40,
        width: 40,
        height: 40,
        marginBottom: 10
    },
    hide: {
        display: 'none'
    }
};