'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _constants = require('../../constants');

var COLORS = _interopRequireWildcard(_constants);

var _View = require('../View');

var _View2 = _interopRequireDefault(_View);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Header = (_temp2 = _class = function (_Component) {
    _inherits(Header, _Component);

    function Header() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Header);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Header.__proto__ || Object.getPrototypeOf(Header)).call.apply(_ref, [this].concat(args))), _this), _this.clickCondition = function (label, value) {
            _this.props.clickCondition && _this.props.clickCondition(label, value);
        }, _this.isChoice = function (value) {
            var isChoice = false;
            if (_this.props.condition.length === 0) {
                isChoice = false;
            } else {
                for (var i = 0; i < _this.props.condition.length; i++) {
                    if (_this.props.condition[i].value === value) {
                        isChoice = true;
                        break;
                    }
                }
            }
            return isChoice;
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }
    // 判断当前的condition是否被选中


    _createClass(Header, [{
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                label = _props.label,
                type = _props.type;

            return _react2.default.createElement(
                _View2.default,
                { style: styles.container },
                this.props.searchCondition.length > 0 && type === 'condition' ? _react2.default.createElement(
                    _View2.default,
                    { style: { flexDirection: 'column', justifyContents: 'center', alignItems: 'center', width: '100%' } },
                    _react2.default.createElement(
                        'div',
                        null,
                        '\u6307\u5B9A\u641C\u7D22\u6761\u4EF6'
                    ),
                    _react2.default.createElement(
                        _View2.default,
                        { style: { alignItems: 'center', justifyContent: 'space-around', width: '90%', marginTop: 30, fontSize: 28, color: COLORS.BLUE_COLOR } },
                        this.props.searchCondition.map(function (data, i) {
                            return _react2.default.createElement(
                                _View2.default,
                                { key: i, style: styles.condition, onClick: function onClick() {
                                        return _this2.clickCondition(data.label, data.value);
                                    } },
                                _react2.default.createElement(
                                    'span',
                                    { style: _this2.isChoice(data.value) ? { color: '#ffffff', backgroundColor: COLORS.BLUE_COLOR, padding: '10px 20px', fontSize: 26, borderRadius: 10 } : { borderBottom: '1px solid ' + COLORS.BLUE_COLOR } },
                                    data.label
                                )
                            );
                        })
                    )
                ) : _react2.default.createElement(
                    _View2.default,
                    null,
                    _react2.default.createElement('img', { src: type === 'search' ? require('../../assets/search.png') : require('../../assets/search-noresult.png'), style: { height: 80 } }),
                    _react2.default.createElement(
                        _View2.default,
                        { style: { alignItems: 'center', marginTop: 10 } },
                        _react2.default.createElement(
                            'span',
                            { style: { fontSize: 28, color: '#bfbfbf' } },
                            label
                        )
                    )
                )
            );
        }
    }]);

    return Header;
}(_react.Component), _class.propTypes = {
    label: _react.PropTypes.string,
    type: _react.PropTypes.oneOf(['search', 'search-noresult', 'condition']),
    searchCondition: _react.PropTypes.any,
    clickCondition: _react.PropTypes.func,
    condition: _react.PropTypes.any
}, _class.defaultProps = {
    label: '查找内容',
    type: 'search',
    searchCondition: []
}, _temp2);
exports.default = Header;


var styles = {
    container: {
        marginTop: 30,
        width: '100%',
        height: 500,
        flexDirection: 'column',
        alignItems: 'center',
        justifyContents: 'center',
        backgroundColor: COLORS.BACKGROUND_COLOR
    },
    condition: {
        width: '30%',
        marginTop: 20,
        height: 50,
        alignItems: 'center',
        justifyContent: 'center'
    }
};