'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _MobileDetect = require('./MobileDetect');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MessageBridge = (_temp = _class = function () {
    function MessageBridge() {
        _classCallCheck(this, MessageBridge);
    }

    _createClass(MessageBridge, null, [{
        key: 'postMessage',


        /**
         * 向Native端发送消息
         * @param message 
         */
        value: function postMessage(message) {
            if (!_MobileDetect.isApp) return;
            var jsonStr = JSON.stringify(message);
            window.postMessage(jsonStr, '*');
        }

        /**
         * 添加监听，接收Native发送的消息
         * @param callback 
         */

    }, {
        key: 'addMessageListener',
        value: function addMessageListener(callback) {
            if (!_MobileDetect.isApp) return;

            var listener = function listener(event) {
                return callback(JSON.parse(event.data));
            };
            window.document.addEventListener('message', listener);
            MessageBridge.listeners.push(callback);
        }

        /**
         * 移除监听
         * @param callback 
         */

    }, {
        key: 'removeMessageListener',
        value: function removeMessageListener(callback) {
            if (!_MobileDetect.isApp) return;

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = MessageBridge.listeners[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var listener = _step.value;

                    if (listener === callback) {
                        window.document.removeEventListener('message', listener);
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            MessageBridge.listeners = MessageBridge.listeners.removeByCondition(function (listener) {
                return listener === callback;
            });
        }

        /**
         * 页面跳转
         * @param url 
         */

    }, {
        key: 'linking',
        value: function linking(url) {
            if (_MobileDetect.isApp) {
                MessageBridge.postMessage({
                    type: 'onPush',
                    payload: url
                });
            } else {
                window.location.href = url;
            }
        }

        /**
         * 分发事件
         * @param eventType 
         * @param payload 
         */

    }, {
        key: 'dispatchEvent',
        value: function dispatchEvent(eventType, payload) {
            MessageBridge.postMessage({ type: eventType, payload: payload });
        }

        /**
         * 按照事件类型监听列表消息
         * @param callback 
         */

    }, {
        key: 'addEventListener',
        value: function addEventListener(eventType, callback) {
            if (!_MobileDetect.isApp) return;
            MessageBridge.postMessage({ type: 'onRegister', payload: eventType });
            // 过滤消息类型
            var listener = function listener(event) {
                var data = JSON.parse(event.data);
                if (data.type === eventType) {
                    callback(data.payload);
                }
            };
            window.document.addEventListener('message', listener);
            if (Array.isArray(MessageBridge.eventListeners[eventType])) {
                MessageBridge.eventListeners[eventType].push(callback);
            } else {
                MessageBridge.eventListeners[eventType] = [callback];
            }
        }

        /**
         * 移除列表消息
         * @param callback 
         */

    }, {
        key: 'removeEventListener',
        value: function removeEventListener(eventType, callback) {
            if (!_MobileDetect.isApp || !Array.isArray(MessageBridge.eventListeners[eventType])) return;

            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
                for (var _iterator2 = MessageBridge.eventListeners[eventType][Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    var listener = _step2.value;

                    if (listener === callback) {
                        window.document.removeEventListener('message', listener);
                    }
                }
            } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }
                } finally {
                    if (_didIteratorError2) {
                        throw _iteratorError2;
                    }
                }
            }

            MessageBridge.listeners = MessageBridge.eventListeners[eventType].removeByCondition(function (listener) {
                return listener === callback;
            });
        }
    }]);

    return MessageBridge;
}(), _class.listeners = [], _class.eventListeners = {}, _temp);
exports.default = MessageBridge;